 
#include <stdio.h>
#include <stdlib.h>	
#include <math.h>	
 

int Read_Section_Nb()
{
	FILE *f;
        float L, l, e;
        int   nb,i;

	f = fopen( "section.dat", "r" );

        if (f!=NULL)
        {
                fscanf(f,"%d", &nb);
        }

	fclose(f);

        return(nb);
}

void Read_Section(float *tab, float *r, char **label)
{
	FILE *f;
        float L, l, e;
        int   nb,i;

	f = fopen( "section.dat", "r" );

        if (f!=NULL)
        {
                fscanf(f,"%d", &nb);

        	for (i=0; i<nb; i++)
        	{

		    fscanf(f,"%f", &L);
		    fscanf(f,"%f", &l);
		    fscanf(f,"%f", &e);

                    if (e<0) 
                    {
                       tab[i] = (L*L - (L-2*l)*(L-2*l))*3.1415926/4.; 

                       r[i] = L/2.;

                       sprintf(label[i],"ø%4.2f %4.2f", L, l); 
 
                    }
                    else 
                    {
                       tab[i] =  L*l - (L-2*e)*(l-2*e);

                       r[i] = L/2.;

                       sprintf(label[i],"%4.2fx%4.2f %4.2f", L, l, e);                        
                    }
		}
        }
	fclose(f);
}

void Read_config(float *p_min, float *p_max, float *p_step, float *diff_max, float *delta_max, float *rho, float *E, float *g, float *M1_min, float *M1_max)
{
	FILE *f;
        int   i;
        char   tmp[200];

	f = fopen( "config.dat", "r" );

        if (f!=NULL)
        {
                fscanf(f,"%f", diff_max);
                fgets(tmp,199,f); 
                fscanf(f,"%f", delta_max);
                fgets(tmp,199,f); 
		fscanf(f,"%f", M1_min);
		fscanf(f,"%f", M1_max);
                fgets(tmp,199,f); 

                fgets(tmp,199,f); 
 
                fscanf(f,"%f", &(rho[0]));
                fscanf(f,"%f", &(rho[1]));
                fscanf(f,"%f", &(rho[2]));
                fgets(tmp,199,f); 
                fscanf(f,"%f", &(E[0]));
                fscanf(f,"%f", &(E[1]));
                fscanf(f,"%f", &(E[2]));
                fgets(tmp,199,f); 
                fscanf(f,"%f", g);
                fgets(tmp,199,f); 

                fgets(tmp,199,f); 

        	for (i=0; i<4; i++)
        	{
		    fscanf(f,"%f", &(p_min[ i] ));
		    fscanf(f,"%f", &(p_max[ i] ));
		    fscanf(f,"%f", &(p_step[i]));
                    fgets(tmp,199,f); 
		}

		fscanf(f,"%f", &(p_min[ 7] ));
		fscanf(f,"%f", &(p_max[ 7] ));
		fscanf(f,"%f", &(p_step[7]));
                fgets(tmp,199,f); 

		fscanf(f,"%f", &(p_min[ 8] ));
		fscanf(f,"%f", &(p_max[ 8] ));
		fscanf(f,"%f", &(p_step[8]));
                fgets(tmp,199,f); 

		fscanf(f,"%f", &(p_min[ 6] ));
		fscanf(f,"%f", &(p_max[ 6] ));
		fscanf(f,"%f", &(p_step[6]));
                fgets(tmp,199,f); 
        }

	fclose(f);
}


int main(int argc, char *argv[])
{
   int   i,j,s_nbmax;
   long  n, nt,nf;
   FILE *f;  
   float x1, x2, p_min[9],p_max[9],p_step[9], p[9], T1, T2, M1, M2, m1, m2, r1, r2, L1, L2, e, rho[3], d1, d2, E[3], g, S1, S2, b,diff_max,delta_max;
   float delta1, delta2, M1_min, M1_max,fac, rho_1, E_1, rho_2, E_2;

   char  **label;
   float *s_tab, *r_tab;

   s_nbmax = Read_Section_Nb();
 
   s_tab  =  (float*) malloc( s_nbmax*sizeof(float) );

   r_tab  =  (float*) malloc( s_nbmax*sizeof(float) );
   
   label  =  (char**) malloc( s_nbmax*sizeof(char*) );
   for (i=0; i<s_nbmax; i++) label[i] =  (char*) malloc( 50*sizeof(char) );
 
   Read_Section(s_tab, r_tab, label);   
 
//------------------------------------------------------------------

   Read_config(p_min, p_max, p_step, &diff_max, &delta_max, rho, E, &g, &M1_min, &M1_max);

//------------------------------------------------------------------

   n  = 0;
   nf = 0;
   nt = 0;

   for (rho_1=rho[0]; rho_1 < rho[1]+rho[2]; rho_1+=rho[2]) 
   { 
	   for (E_1=E[0]; E_1 < E[1]+E[2]; E_1+=E[2]) 
	   { 
		   for (rho_2=rho[0]; rho_2 < rho[1]+rho[2]; rho_2+=rho[2]) 
		   { 
			for (E_2=E[0]; E_2 < E[1]+E[2]; E_2+=E[2]) 
   			{ 
				for (p[7]=p_min[7]; p[7] < p_max[7]+p_step[7]; p[7]+=p_step[7]) 
				{ 
   					for (p[8]=p_min[8]; p[8] < p_max[8]+p_step[8]; p[8]+=p_step[8]) 
   					{ 
   						for (p[6]=p_min[6]; p[6] < p_max[6]+p_step[6]; p[6]+=p_step[6]) 
   						{ 
    							for (p[0]=p_min[0]; p[0] < p_max[0]+p_step[0]; p[0]+=p_step[0]) 
    							{
     								for (p[1]=p_min[1]; p[1] < p_max[1]+p_step[1]; p[1]+=p_step[1]) 
     								{
       									for (p[2]=p_min[2]; p[2] < p_max[2]+p_step[2]; p[2]+=p_step[2]) 
       									{
         									for (p[3]=p_min[3]; p[3] < p_max[3]+p_step[3]; p[3]+=p_step[3]) 
         									{ 
           										for (i=0; i< s_nbmax; i++)
           										{
             											for (j=0; j< s_nbmax; j++)
             											{
                											nt++;
             											}
           										}
         									}
       									}
     								}
    							}
    						}
    					}
    				}
    			}
    		}
    	}
   }

   f = fopen( "sol_serrurier.txt", "w" );    

   for (rho_1=rho[0]; rho_1 < rho[1]+rho[2]; rho_1+=rho[2]) 
   { 
   	for (E_1=E[0]; E_1 < E[1]+E[2]; E_1+=E[2]) 
   	{ 
   		for (rho_2=rho[0]; rho_2 < rho[1]+rho[2]; rho_2+=rho[2]) 
   		{ 
   			for (E_2=E[0]; E_2 < E[1]+E[2]; E_2+=E[2]) 
   			{ 
   				for (p[7]=p_min[7]; p[7] < p_max[7]+p_step[7]; p[7]+=p_step[7]) 
   				{ 
   					for (p[8]=p_min[8]; p[8] < p_max[8]+p_step[8]; p[8]+=p_step[8]) 
   					{ 
   						for (p[6]=p_min[6]; p[6] < p_max[6]+p_step[6]; p[6]+=p_step[6]) 
   						{ 
    							for (p[0]=p_min[0]; p[0] < p_max[0]+p_step[0]; p[0]+=p_step[0]) 
    							{
     								for (p[1]=p_min[1]; p[1] < p_max[1]+p_step[1]; p[1]+=p_step[1]) 
     								{
       									for (p[2]=p_min[2]; p[2] < p_max[2]+p_step[2]; p[2]+=p_step[2]) 
       									{
         									for (p[3]=p_min[3]; p[3] < p_max[3]+p_step[3]; p[3]+=p_step[3]) 
         									{ 
           										for (i=0; i< s_nbmax; i++)
           										{
             											p[4]=s_tab[i];

             											for (j=0; j< s_nbmax; j++)
             											{
                						 					p[5]=s_tab[j];

                						 					M2 = p[0];
                						 					L1 = p[1]/1.e3;
                						 					L2 = p[2]/1.e3;
                						 					d1 = p[7]/1.e3;
                						 					d2 = p[8]/1.e3;
                						 					r1 = r_tab[i]/1.e3;
                						 					r2 = r_tab[j]/1.e3;
                						 					 e = p[3]/1.e3; 
                						 					 b = p[6]/1.e3; 
                						 					S1 = p[4]/1.e6;
                						 					S2 = p[5]/1.e6;                                  
                       					
													x1 = ( -b/2*r1*r1 + r1 * sqrt( pow( b/2*r1,2 ) + ( pow(L1-d1-e,2)-r1*r1)*( pow(L1-d1-e,2) + b*b/4 ) ) )/( pow(L1-d1-e,2)-r1*r1 );	 
													x2 = ( -b/2*r2*r2 + r2 * sqrt( pow( b/2*r2,2 ) + ( pow(L2-d2-e,2)-r2*r2)*( pow(L2-d2-e,2) + b*b/4 ) ) )/( pow(L2-d2-e,2)-r2*r2 );	

                						 					T1 = sqrt( pow(L1-d1-e,2) + pow(b/2.-x1,2) );
                						 					T2 = sqrt( pow(L2-d2-e,2) + pow(b/2.-x2,2) );

                						 					m1 = 8*rho_1*T1*S1;
                						 					m2 = 8*rho_2*T2*S2;

                						 					M1 = ( M2*L2 + ( (L2-d2+e)*m2 -(L1-d1+e)*m1  )/2 )/L1;
		
                						 					delta1 = (M1+m1/2)*pow(T1,3)*g/(E_1*S1*b*b)*1.e6; 
                						 					delta2 = (M2+m2/2)*pow(T2,3)*g/(E_2*S2*b*b)*1.e6; 
                						 					n++;
	
                						 					if ( ( M1>=M1_min )&&( M1<=M1_max )&&( delta1<delta_max )&&( delta2<delta_max )&&( fabs(delta2-delta1)<diff_max) ) 
                						 					{
                						 						nf++;
	
                						 						if (nf==1) fprintf(f,"No_solution Section_Tube1(mm) Epaisseur_Tube1(mm) Section_Tube2(mm) Epaisseur_Tube2(mm) S1(mm²) S2(mm²) L1(mm) L2(mm) M1(Kg) M2(Kg) e(mm) b(mm) Delta1(micro_m) Delta2(micro_m) Diff_Delta(micro_m) L1+L2+140+260-50(mm) M1+M2+Masse_Tubes(kg) T1(mm) T2(mm) Masse_1Tube1(kg) Masse_1Tube2(kg) Rho1(kg/m3) E1(Pa) Rho2(kg/m3) E2(Pa)\n");   
                     
                						 						fprintf(f,"%ld %s %s %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.1f %1.2f %1.2f %1.2f %1.2e %1.2f %1.2e\n", nf, label[i], label[j], p[4], p[5], p[1], p[2], M1, p[0], p[3], p[6], delta1, delta2, fabs(delta2-delta1), p[1]+p[2]+140+260-50, M1+M2+m1+m2, T1*1e3, T2*1e3, m1/8, m2/8, rho_1, E_1, rho_2, E_2);   
                    
                						 					}
	
                						 					if (nf<2) printf("%3.1f (%ld sur %ld cas): %ld solution\n", (n*100.)/nt, n, nt,nf);
													else      printf("%3.1f (%ld sur %ld cas): %ld solutions\n", (n*100.)/nt, n, nt,nf);  
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
    	}
   }
 
   fclose(f);

   return 1;
}

